/***************************************************************************
                          configure.h  -  description
                             -------------------
    begin                : Sat Feb 10 2001
    copyright            : (C) 2001 by Michael Ramsza
    email                : mramsz@sgh.waw.pl
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* reader for config files */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_STRING_LENGTH 200  /* max. length of line in config file */
#define COMMENT_STRING '#' /* starts comment line */
#define EQUALS '=' /* equality character */


int remove_spaces(char *st){
    int l,m;

    l=0;
    while( st[l]!= '\0'){
			if((st[l] == ' ') || (st[l] == '\n')){
	    	m=l;
	    	while(st[m] != '\0'){
					st[m]=st[m+1]; m++; }
	    	l=-1;}
			l++;
		}
    return 0;
}


int configure(FILE *config_file, char *var_name, char *var_type, void *var){

    char *s;
    char row[MAX_STRING_LENGTH];    

    /* reading data from config file */
    while( fgets(row, MAX_STRING_LENGTH, config_file) != NULL){
	if( (s = strchr(row,COMMENT_STRING)) != NULL){
	    *s = '\0'; }
	    remove_spaces(row);
	if( strstr(row,var_name) != NULL ){
	    s = strchr(row,EQUALS); s++;
	    if( strcmp("int",var_type) == 0){
		*((int *) var) = atoi(s); }
	    if( strcmp("float",var_type) == 0){
		*((float *) var) = atof(s); }
	    if( strcmp("string",var_type) == 0){
		strcpy((char *) var, s); }		
	    }}    
    rewind(config_file);
    return 0;
}
